<?php

/**
 * @file
 * Implement hooks related to the LEAF Baseline module.
 */

use Drupal\Component\Serialization\Json;
use Drupal\Component\Utility\Html;
use Drupal\Core\Cache\CacheableMetadata;
use Drupal\Core\Entity\Display\EntityViewDisplayInterface;
use Drupal\Core\Entity\EntityInterface;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Template\Attribute;
use Drupal\Core\Url;
use Drupal\field\Entity\FieldConfig;
use Drupal\group\Entity\Group;
use Drupal\group\Entity\GroupContent;
use Drupal\node\Entity\Node;
use Drupal\node\NodeInterface;
use Drupal\profile\Entity\Profile;
use Drupal\profile\Entity\ProfileType;
use Drupal\taxonomy\Entity\Term;
use Drupal\user\Entity\User;
use Drupal\views\ViewExecutable;

/**
 * Implements hook_library_info_alter().
 */
function leaf_baseline_library_info_alter(&$libraries, $extension) {
  $library_name = 'init';
  if ($extension === 'openseadragon' && isset($libraries[$library_name]['js'])) {
    $openseadragon_path = 'js';
    $overwrite_path = '/' . \Drupal::service('extension.list.module')
      ->getPath('leaf_baseline') . '/js';
    $overwrite_js = [];
    $replacements = [
      $openseadragon_path . '/openseadragon_viewer.js' => $overwrite_path . '/openseadragon_viewer_overwrite.js',
    ];
    $swapped = FALSE;
    foreach ($libraries[$library_name]['js'] as $source => $options) {
      if (isset($replacements[$source])) {
        $overwrite_js[$replacements[$source]] = $options;
        $swapped = TRUE;
      }
      else {
        $overwrite_js[$source] = $options;
      }
    }
    $libraries[$library_name]['js'] = $overwrite_js;
    if ($swapped) {
      $libraries[$library_name]['dependencies'][] = 'core/once';
    }
  }
}

/**
 * Implements hook_preprocess_HOOK() for openseadragon_iiif_manifest_block template.
 */
function leaf_baseline_preprocess_openseadragon_iiif_manifest_block(array &$variables) {
  if (!empty($variables['#attached']['drupalSettings']['openseadragon'])) {
    return;
  }

  $manifest_url = $variables['iiif_manifest_url'] ?? '';
  if (!$manifest_url || !($current_node = \Drupal::routeMatch()->getParameter('node'))) {
    return;
  }

  $cache_meta = CacheableMetadata::createFromRenderArray($variables);

  // Load the global settings.
  $config = \Drupal::service('openseadragon.config');
  $cache_meta->addCacheableDependency($config);
  $viewer_settings = $config->getSettings(TRUE);
  $iiif_address = $config->getIiifAddress();
  if (!($iiif_address = $config->getIiifAddress())) {
    $cache_meta->applyTo($variables);
    return;
  }

  // Build the gallery id.
  $openseadragon_viewer_id = Html::getUniqueId('openseadragon-viewer-iiif-manifest-block');

  // Attach the viewer, using the image urls obtained from the manifest.
  $variables['#attached']['library'][] = 'openseadragon/init';
  $settings = [
    'basePath' => Url::fromUri($iiif_address),
    'fitToAspectRatio' => $viewer_settings['fit_to_aspect_ratio'],
    'manifestUrl' => \Drupal::token()->replace($manifest_url, ['node' => $current_node]),
    'options' => [
      'id' => $openseadragon_viewer_id,
      'prefixUrl' => 'https://cdnjs.cloudflare.com/ajax/libs/openseadragon/2.4.2/images/',
      'tileSources' => [],
    ] + $viewer_settings,
  ];

  $variables['attributes'] = $variables['attributes'] ?? new Attribute();
  $variables['attributes']['class'][] = 'openseadragon-viewer';
  $variables['attributes']['id'] = $openseadragon_viewer_id;
  $variables['attributes']['data-open-seadragon-settings'] = Json::encode($settings);

  $cache_meta->applyTo($variables);
}

/**
 * Implements hook_menu_local_tasks_alter().
 */
function leaf_baseline_menu_local_tasks_alter(&$data, $route_name) {
  $current_path = \Drupal::service('path.current')->getPath();
  $path_args = explode('/', $current_path);

  if (!empty($path_args)) {
    if ($path_args[1] == 'node' && is_numeric($path_args[2])) {
      $node = Node::load($path_args[2]);
      $content_type = $node->bundle();
      if ($content_type == 'islandora_object') {
        $resource_type_term = $node->get('field_resource_type')->referencedEntities();
        $model_term = $node->get('field_model')->referencedEntities();

        if (!empty($resource_type_term) && !empty($model_term)) {
          if ($resource_type_term[0]->label() == "Collection" && $model_term[0]->label() == "Collection") {
            if (!empty($path_args[3]) && $path_args[3] == 'about') {
            }
            else {
              // Remove all tabs from collection.
              foreach ($data['tabs'][0] as $key => $tab) {
                $data['tabs'][0][$key]['#access'] = FALSE;
              }
            }
          }
        }

        if (in_array($route_name, ['view.manage_about.page_1', 'entity.node.canonical', 'leaf_writer.edit.content', 'leaf_dtoc.edit.content']) && isset($data['tabs'][0])) {
          // Remove all tabs from node page.
          foreach ($data['tabs'][0] as $key => $tab) {
            if (in_array($key, ['views_view:view.manage_about.page_1', 'entity.node.canonical', 'leaf_writer.edit.content', 'leaf_dtoc.edit.content'])) {
              continue;
            }
            $data['tabs'][0][$key]['#access'] = FALSE;
          }
        }
      }
    }
    if ((!empty($path_args[1]) && $path_args[1] == 'user') && (!empty($path_args[2]) && is_numeric($path_args[2]))) {
      $all_profile_type = ProfileType::loadMultiple();
      $profile_type_name = array_keys($all_profile_type);

      foreach ($data['tabs'] as $key => $tab) {
        foreach ($tab as $tab_link_key => $tab_link_value) {
          foreach ($profile_type_name as $profile_type) {
            if ($tab_link_key == "profile.user_page:$profile_type") {
              unset($data['tabs'][$key][$tab_link_key]);
            }
          }
        }
      }
    }
  }

  if ($current_path == '/user/login') {
    $data['tabs'][0]['user.login']['#weight'] = 11;
    $data['tabs'][0]['user.register']['#weight'] = 10;
  }

  // Hide tabs from homepage.
  if (\Drupal::service('path.matcher')->isFrontPage()) {
    unset($data['tabs']);
  }
}

/**
 * Implements hook_theme().
 */
function leaf_baseline_theme($existing, $type, $theme, $path) {
  return [
    'citation_block' => [
      'variables' => [
        'thumbnail_image' => '',
        'citation_text' => '',
      ],
    ],
    'project_theme_page' => [
      'variables' => [
        'color_options' => '',
      ],
    ],
  ];
}

/**
 * Implements hook_preprocess_container__collapsible().
 */
function leaf_baseline_preprocess_container__collapsible(&$variables) {
  // Recovering variables processing from original container preprocess.
  template_preprocess_container($variables);
  // Details classes based on the admin theme.
  $config = \Drupal::service('config.factory');
  $admin_theme = $config->get('system.theme')->get('admin');
  $variables['details_attributes'] = new Attribute();
  $variables['summary_attributes'] = new Attribute();
  if ($admin_theme == 'claro') {
    $variables['details_attributes']->addClass('claro-details');
    $variables['summary_attributes']->addClass('claro-details__summary');
    $variables['attributes']['class'][] = 'claro-details__wrapper';
  }
}

/**
 * Implements hook_preprocess_HOOK() for block templates.
 */
function leaf_baseline_preprocess_block(&$variables) {
  if (!empty($variables['configuration']['provider']) && $variables['configuration']['provider'] == 'layout_builder') {
    $variables['label'] = !empty($variables['configuration']['label_display']) ? $variables['configuration']['label'] : '';
  }
}

/**
 *
 */
function leaf_baseline_views_pre_view(ViewExecutable $view, $display_id, array &$args) {
  $node = \Drupal::routeMatch()->getParameter('node');
  if ($view->id() == 'featured_object_for_current_group_content') {
    if ($node instanceof NodeInterface) {
      $nid = $node->id();
      $gids = get_groups_from_node($nid);
      if (!empty($gids)) {
        $args[0] = $gids[0];
      }
    }
  }

  // Hide SBF profile filter from other group profile gallery.
  $group = \Drupal::routeMatch()->getParameter('group');
  if (!empty($group) || ($node instanceof NodeInterface)) {
    if ($view->id() == "group_members_gallery" && $display_id == "block_1") {

      if (!empty($node)) {
        $nid = $node->id();
        $gid = get_groups_from_node($nid);
        $group_id = reset($gid);
        $group = Group::load($group_id);
      }

      $member_profile_field_val = $group->get("field_member_profile")->getValue();
      $hide_member_gallery_filters = $group->get("field_hide_member_gallery_filter")->getString();

      // Profile Filter exist, then don't show member gallery view as fallback.
      if (!empty(\Drupal::request()->query->get('field_committee_cluster_value'))) {
        $view->execute();
        $result = $view->result;

        if (empty($result)) {
          $view->display_handler->setOption('css_class', 'no_record_found');
        }
      }

      if (empty($member_profile_field_val)) {
        unset($view->display_handler->default_display->options['filters']);
        unset($view->display_handler->default_display->options['sorts']);
        $view->display_handler->setOption('css_class', 'non_sbf_profile_gallery');
      }
      else {
        $profile_id = $member_profile_field_val[0]['target_id'];

        if (!empty($hide_member_gallery_filters) && $hide_member_gallery_filters == "1") {
          unset($view->display_handler->default_display->options['filters']);
          unset($view->display_handler->default_display->options['sorts']);
          $view->display_handler->setOption('css_class', 'non_sbf_profile_gallery');
        }
      }
    }
  }

  // Hide VBO action, if group member role doesn't match.
  if ($view->id() == "group_nodes") {
    $show_vbo = FALSE;

    if (!empty(array_intersect(['administrator'], \Drupal::currentUser()->getRoles()))) {
      $show_vbo = TRUE;
    }
    else {
      $currentAccount = \Drupal::currentUser();
      $current_group_member = $group->getMember($currentAccount);

      $curr_old_group_content = $current_group_member->getGroupContent();

      if ($curr_old_group_content->hasField('group_roles')) {
        $curr_group_role_arr = $curr_old_group_content->get('group_roles')->getValue();
        if (!empty($curr_group_role_arr)) {
          foreach ($curr_group_role_arr as $curr_group_role_val) {
            if (in_array($curr_group_role_val['target_id'], ["project-editor", "project-technician"])) {
              $show_vbo = TRUE;
            }
          }
        }
      }
    }

    if (!$show_vbo) {
      $view->removeHandler($display_id, 'field', 'views_bulk_operations_bulk_form');
    }
  }
}

/**
 *
 */
function get_groups_from_node($nid) {
  $group_ids = [];
  $ids = \Drupal::entityQuery('group_content')
    ->accessCheck(TRUE)
    ->condition('entity_id', $nid)
    ->execute();

  $relations = GroupContent::loadMultiple($ids);
  foreach ($relations as $rel) {
    if ($rel->getEntity()->getEntityTypeId() == 'node') {
      $group_ids[] = $rel->getGroup()->id();
    }
  }

  return $group_ids;
}

/**
 *
 */
function get_groups_object_from_node($nid) {
  $group = [];
  $ids = \Drupal::entityQuery('group_content')
    ->accessCheck(TRUE)
    ->condition('entity_id', $nid)
    ->execute();

  $relations = GroupContent::loadMultiple($ids);
  foreach ($relations as $rel) {
    if ($rel->getEntity()->getEntityTypeId() == 'node') {
      $group[] = $rel->getGroup();
    }
  }

  return $group;
}

/**
 * Implements hook_preprocess_HOOK() for page.
 */
function leaf_baseline_preprocess_page(&$variables) {
  if ($variables['logged_in']) {
    return;
  }

  // Excluding the user login path for destination.
  $variables['#attached']['drupalSettings']['leafbaseline']['destinationPath']['excludedPathNames'][] = '/user/login';
  $site_front_page = \Drupal::config('system.site')->get('page.front');
  $variables['#attached']['library'][] = 'leaf_baseline/destination-path';
  $variables['#attached']['drupalSettings']['leafbaseline']['destinationPath']['siteFrontPage'] = $site_front_page;
}

/**
 * Implements hook_token_info().
 */
function leaf_baseline_token_info() {
  $info = [];
  $info['tokens']['leaf_baseline']['banner_heading_anonymous'] = [
    'name' => t('Banner Heading Anonymous'),
    'description' => t('Banner heading text for anonymous users.'),
  ];

  return $info;
}

/**
 * Implements hook_tokens().
 */
function leaf_baseline_tokens($type, $tokens, array $data = [], array $options = []) {
  $replacements = [];

  if ($type == 'leaf_baseline') {
    foreach ($tokens as $name => $original) {
      switch ($name) {
        case 'banner_heading_anonymous':
          $theme_branding = theme_get_setting('theme_brand');
          $banner_heading_text = 'Canadian Writing Research Collaboratory';

          if ($theme_branding == 'bucknell') {
            $banner_heading_text = 'LEAF at Bucknell';
          }

          $replacements[$original] = $banner_heading_text;
          break;
      }
    }
  }

  return $replacements;
}

/**
 * Implements hook_form_BASE_FORM_ID_alter().
 */
function leaf_baseline_form_alter(&$form, FormStateInterface $form_state, $form_id) {
  if ($form_id == "views_form_my_collaborations_block_3_1") {
    $form["header"]["node_bulk_form"]["action"]["#default_value"] = "node_break_lock_action";
    $form["actions"]["submit"]["#value"] = t("release Selected Locks");
  }
  if ($form_id == 'user_form') {
    $form['field_reason_for_joining']['widget'][0]['value']['#attributes']['readonly'] = 'readonly';
  }

  // Adding custom group member data submit.
  if ($form_id == 'group_content_project-group_membership_edit_form' || $form_id == 'group_content_project-group_membership_add_form') {
    $group = \Drupal::routeMatch()->getParameter('group');
    $langcode = \Drupal::languageManager()->getCurrentLanguage()->getId();

    if (is_numeric($group)) {
      // Load group entity.
      $group = Group::load($group);

      if ($group->hasTranslation($langcode)) {
        $group = $group->getTranslation($langcode);
      }
    }

    if (!isset($group)) {
      return;
    }

    $member_profile_field_val = $group->get("field_member_profile")->getValue();

    if (empty($member_profile_field_val)) {
      return;
    }

    $member_profile_id = $group->get("field_member_profile")->getValue()[0]['target_id'];

    $entity = \Drupal::entityTypeManager()->getStorage('profile')->create([
      'type' => $member_profile_id,
    ]);

    if (!$entity->hasField("field_group_id")) {
      return;
    }

    $show_field = FALSE;

    // Make show field true if group role is editor.
    if (!empty(array_intersect(['administrator'], \Drupal::currentUser()->getRoles()))) {
      $show_field = TRUE;
    }

    if (!empty($form['entity_id'])) {
      if (!empty($group)) {
        $gid = $group->id();

        if (!$show_field) {
          $currentAccount = \Drupal::currentUser();
          $current_group_member = $group->getMember($currentAccount);

          $curr_old_group_content = $current_group_member->getGroupContent();
          if ($curr_old_group_content->hasField('group_roles')) {
            $curr_group_role_arr = $curr_old_group_content->get('group_roles')->getValue();

            if (!empty($curr_group_role_arr)) {
              foreach ($curr_group_role_arr as $curr_group_role_val) {
                if ($curr_group_role_val['target_id'] == "project-editor") {
                  $show_field = TRUE;
                }
              }
            }
          }
        }

        $user = $form['entity_id']['widget'][0]['target_id']['#default_value'];
        if (!empty($user)) {
          $query = \Drupal::entityQuery('profile')
            ->condition('type', $member_profile_id)
            ->condition('uid', $user->id())
            ->condition('field_group_id', $gid)
            ->accessCheck(TRUE);
          $pids = $query->execute();
          if (!empty($pids)) {
            $profile_id = reset($pids);
            $entity = Profile::load($profile_id);
          }
        }
      }
    }

    $form_state->set('entity', $entity);

    if ($member_profile_id == "sbf_group_profile") {
      // To make `Feature Non-SBF/MSMA Project` fieldset collapsible.
      $form['feature_non_sbf_proj'] = [
        '#type' => 'details',
        '#title' => t('Feature Non-SBF/MSMA Project'),
        '#collapsible' => TRUE,
        '#collapsed' => TRUE,
        '#weight' => 33,
      ];

      // To make `Quote about SBF/MSMA Involvement` fieldset collapsible.
      $form['quote_about_sbf_involvement'] = [
        '#type' => 'details',
        '#title' => t('Quote about SBF/MSMA Involvement'),
        '#collapsible' => TRUE,
        '#collapsed' => TRUE,
        '#weight' => 33,
      ];
    }

    $form_display = \Drupal::entityTypeManager()->getStorage('entity_form_display')->load('profile.' . $member_profile_id . '.default');

    if (!empty($form_display)) {
      foreach ($form_display->getComponents() as $name => $component) {
        if (in_array($name, ["langcode", "translation"])) {
          continue;
        }

        $widget = $form_display->getRenderer($name);
        if (!$widget) {
          continue;
        }

        $items = $entity->get($name);
        $items->filterEmptyItems();

        if (in_array($name, ["field_feature_non_sbf_proj_title", "field_feature_non_sbf_paragraph", "field_feature_non_sbf_proj_link", "field_feature_non_sbf_proj_image"])) {

          $form['feature_non_sbf_proj'][$name]['#parents'] = [];
          $form['feature_non_sbf_proj'][$name] = $widget->form($items, $form, $form_state);
          $form['feature_non_sbf_proj'][$name]['#access'] = $items->access('edit');

          if ($name == "field_feature_non_sbf_proj_title") {
            $form['feature_non_sbf_proj']["field_feature_non_sbf_proj_title"]['#weight'] = -1;
          }
        }
        elseif (in_array($name, ["field_quote_abt_sbf_involvement"])) {
          $form['quote_about_sbf_involvement'][$name]['#parents'] = [];
          $form['quote_about_sbf_involvement'][$name] = $widget->form($items, $form, $form_state);
          $form['quote_about_sbf_involvement'][$name]['#access'] = $items->access('edit');
        }
        else {
          $form[$name]['#parents'] = [];
          $form[$name] = $widget->form($items, $form, $form_state);
          $form[$name]['#access'] = $items->access('edit');
          $form[$name]['#weight'] = 32;

          if ($name == "field_professional_email") {
            $form["field_professional_email"]['#access'] = FALSE;

            // Show professional email field.
            if ($show_field) {
              $form["field_professional_email"]['#access'] = TRUE;
            }
          }

          if ($name == "field_profile_consent") {
            $form["field_profile_consent"]['#weight'] = 31;
          }
        }
      }
    }

    $form["revision_log_message"]['#access'] = FALSE;
    $form['actions']['submit']['#submit'][] = 'leaf_baseline_group_membership_submit';
  }

  // Profile type add/edit form alter to add group list field.
  if ($form_id == 'profile_type_add_form' || $form_id == 'profile_type_edit_form') {
    $profile_type_id = $form_state->getFormObject()->getEntity()->id();

    $result = \Drupal::database()->select('group__field_member_profile', 'gmf')
      ->fields('gmf', ['entity_id'])
      ->condition('gmf.bundle', "project", '=')
      ->condition('gmf.field_member_profile_target_id', $profile_type_id, '=')
      ->execute()
      ->fetchAll();

    $profile_group_default_val = NULL;
    if (!empty($result)) {
      foreach ($result as $res) {
        $profile_group_default_val[] = \Drupal::entityTypeManager()->getStorage('group')->load($res->entity_id);
      }
    }

    $form['profile_group'] = [
      '#type' => 'entity_autocomplete',
      '#title' => t('Include In Group'),
      '#description' => t('Select group name where you would like to attach this profile.'),
      '#default_value' => !empty($profile_group_default_val) ? $profile_group_default_val : NULL,
      '#target_type' => 'group',
      '#tags' => TRUE,
      '#selection_settings' => [
        'target_bundles' => ['project'],
      ],
    ];

    $form['actions']['submit']['#submit'][] = 'leaf_baseline_profile_form_submit';
  }

  if ($form_id == 'profile_type_add_form') {
    // Hiding save and manage field button.
    $form["actions"]["save_continue"]["#access"] = FALSE;

    // Adding group id field on new profile type create.
    $form['actions']['submit']['#submit'][] = 'leaf_baseline_profile_add_field_on_submit';
  }
}

/**
 *
 */
function leaf_baseline_profile_add_field_on_submit(&$form, FormStateInterface $form_state) {
  $fieldNames = ["field_group_id" => "Group Id", "field_profile_consent" => "Profile Consent"];
  $profile_type = $form_state->getformObject()->getEntity()->id();

  if ($profile_type == "sbf_group_profile") {
    return;
  }

  $message = "";

  foreach ($fieldNames as $field_machine_name => $field_title) {
    // Create an existing field into profile type.
    $field = FieldConfig::loadByName("profile", $profile_type, $field_machine_name);
    if (empty($field)) {
      $entityTypemanager = \Drupal::entityTypeManager();

      FieldConfig::create(
        [
          'field_name'   => $field_machine_name,
          'entity_type'  => "profile",
          'bundle'       => $profile_type,
          'label'        => $field_title,
          'required'     => FALSE,
          'translatable' => TRUE,
        ]
      )->save();

      $message .= "\n" . t(
        "Field @a created in bundle @b.",
        ['@a' => $field_machine_name, '@b' => $profile_type]
      );

      $display_repository = \Drupal::service('entity_display.repository');
      if ($field_machine_name == "field_profile_consent") {
        $display_repository->getFormDisplay('profile', $profile_type)
          ->setComponent('field_profile_consent', [
            'type'   => "boolean_checkbox",
          ])
          ->save();
      }
    }
  }

  if (!empty($message)) {
    \Drupal::messenger()->addMessage($message);
  }
}

/**
 * Custom submit handler for profile form.
 */
function leaf_baseline_profile_form_submit(&$form, FormStateInterface $form_state) {
  $form_value = $form_state->getValues();
  $profile_id = $form_value["id"];
  $gid_array = $form_value["profile_group"];

  $profile_group_default_array = $form['profile_group']['#default_value'];
  $profile_group_default_gids = [];
  if (!empty($profile_group_default_array)) {
    foreach ($profile_group_default_array as $profile_group_default_val) {
      $profile_group_default_gids[] = $profile_group_default_val->id();
    }
  }

  if (!empty($gid_array)) {
    $new_gids = [];
    foreach ($gid_array as $gid) {
      $new_gids[] = $gid["target_id"];
      $group = \Drupal::entityTypeManager()->getStorage('group')->load($gid["target_id"]);
      $group->set('field_member_profile', $profile_id);
      $group->save();
    }
  }

  if (!empty($profile_group_default_gids)) {
    foreach ($profile_group_default_gids as $val) {
      if (empty($new_gids)) {
        $group = \Drupal::entityTypeManager()->getStorage('group')->load($val);
        $group->set('field_member_profile', NULL);
        $group->save();
      }
      else {
        if (!in_array($val, $new_gids)) {
          $group = \Drupal::entityTypeManager()->getStorage('group')->load($val);
          $group->set('field_member_profile', NULL);
          $group->save();
        }
      }
    }
  }
}

/**
 * Implements hook_views_pre_build().
 */
function leaf_baseline_views_pre_build(ViewExecutable $view) {
  $current_path = \Drupal::service('path.current')->getPath();
  $path_args = explode('/', $current_path);

  if (!empty($path_args)) {
    if ($path_args[1] == 'node' && is_numeric($path_args[2])) {
      $nid = $path_args[2] ?? '';
      $gid = get_groups_from_node($nid);
      $group_id = reset($gid);

      if ($view->id() == 'group_members_gallery' && in_array($view->getDisplay()->display['id'], ['block_1'])) {
        $view->args[0] = $group_id;
        $view->args[1] = $group_id;
      }
    }
  }

  // Setting view argument programmatically.
  if (!in_array($view->id(), ['content_revision_custom', 'my_collaborations', 'group_members_gallery', 'solr_search_content'])) {
    return;
  }

  if (!empty($path_args)) {
    if ((!empty($path_args[1]) && $path_args[1] == "user") && is_numeric($path_args[2]) && (!empty($path_args[3]) && in_array($path_args[3], ['dashboard', 'object-assigned']))) {
      if ($view->id() == 'content_revision_custom' && in_array($view->getDisplay()->display['id'], ['block_1', 'block_2', 'page_1'])) {
        $user = User::load($path_args[2]);
        $name = $user->get('name')->value;
        $view->args[0] = $name;
      }
      if ($view->id() == 'my_collaborations' && in_array($view->getDisplay()->display['id'], ['block_1', 'block_2', 'block_3', 'attachment_1'])) {
        $view->args[0] = $path_args[2];
      }
    }

    if ((!empty($path_args[1]) && $path_args[1] == "group") && is_numeric($path_args[2])) {
      if ($view->id() == 'group_members_gallery' && in_array($view->getDisplay()->display['id'], ['block_1'])) {
        $view->args[1] = $path_args[2];
      }
    }

    if ((!empty($path_args[1]) && $path_args[1] == "solr-search")) {
      if ($view->id() == 'solr_search_content' && in_array($view->getDisplay()->display['id'], ['page_1'])) {
        $currentAccount = \Drupal::currentUser();

        $groups = Group::loadMultiple();
        $gids = [];
        foreach ($groups as $group) {
          $current_group_member = $group->getMember($currentAccount);

          if (!empty($current_group_member)) {
            $gids[] = $group->id();
          }
        }

        if (!empty($gids)) {
          $gids_args = implode("+", $gids);
          $view->setArguments([$gids_args]);
        }
        else {
          $view->setArguments(['0']);
        }
      }
    }
  }
}

/**
 * Implements hook_field_widget_single_element_form_alter().
 */
function leaf_baseline_field_widget_single_element_form_alter(&$element, FormStateInterface $form_state, $context) {
  if (!empty($element['#title']) && $element['#title'] == "Reason for Joining" && $context['items']->getName() == "field_reason_for_joining") {
    $theme_branding = theme_get_setting('theme_brand', 'leaf_base');
    $theme_list = [
      'LEAF' => t('LEAF'),
      'bucknell' => t('Bucknell'),
      'newcastle' => t('Newcastle'),
      'CWRC' => t('CWRC'),
    ];

    if (!empty($theme_branding)) {
      $theme_name = $theme_list[$theme_branding];

      if (!empty($theme_name)) {
        $element['value']['#title'] = t("Reason for Joining $theme_name");
      }
    }

    $current_path = \Drupal::service('path.current')->getPath();

    // Make field required on user register page.
    if ($current_path == "/user/register") {
      $element['value']['#required'] = TRUE;
    }
  }

  if (!empty($element['#title']) && $element['#title'] == "Profile Consent" && $context['items']->getName() == "field_profile_consent") {
    $group = \Drupal::routeMatch()->getParameter('group');

    if (!empty($group)) {
      if (is_numeric($group)) {
        // Load group entity.
        $group = Group::load($group);
      }

      $group_name = $group->label();
      $element['value']['#title'] = "<p class='action-link--danger'><strong>" . t("I consent to having my profile information published on the {$group_name} pages. (Private information such as email address will only be available to other {$group_name} members.)") . "</strong></p>";
    }
  }
}

/**
 * Implements hook_entity_view_mode_alter().
 */
function leaf_baseline_entity_view_mode_alter(&$view_mode, EntityInterface $entity, $context) {
  if ($entity->bundle() == 'islandora_object' && $view_mode == 'compound_member') {
    if (isset($entity->get('field_model')->entity) && isset($entity->get('field_resource_type')->entity)) {
      $resource_type = $entity->get('field_resource_type')->entity->getName();
      $model = $entity->get('field_model')->entity->getName();
      if ($resource_type == 'Text' && in_array($model, ["Bibliographic Record", "Citation"])) {
        $view_mode = 'bibliography';
      }
    }
  }
  if ($entity->bundle() == 'islandora_object') {
    if (isset($entity->get('field_display_hints')->entity)) {
      $display_hint = $entity->get('field_display_hints')->entity->getName();
      if ($display_hint == 'Open Seadragon') {
        $route_name = \Drupal::routeMatch()->getRouteName();
        if ($route_name == 'entity.node.canonical') {
          $view_mode = 'openseadragon_single_page_item';
        }
      }
    }
  }
}

/**
 * Helper function to return hex color of specific theme.
 */
function leaf_baseline_project_theme_hex_color($theme_name = "", $all_hex_colors = FALSE) {
  $project_themes_with_colorcode = [
    "blood_orange" => "#C54700",
    "burnt_sienna" => "#973313",
    "desert" => "#B8671C",
    "forest" => "#224B22",
    "marine" => "#094063",
    "pomegranate" => "#67152B",
    "sage" => "#65785C",
  ];

  // Return all hex colors;.
  if ($all_hex_colors) {
    return $project_themes_with_colorcode;
  }

  if (empty($theme_name)) {
    return;
  }
  if (!empty($theme_name) && $theme_name == "default") {
    return;
  }

  return $project_themes_with_colorcode[$theme_name];
}

/**
 * Overrides theme for getting hex colors.
 *
 * @param $variables
 */
function leaf_baseline_preprocess_project_theme_page(&$variables) {
  $variables['project_theme_colors'] = leaf_baseline_project_theme_hex_color("", $all_hex_colors = TRUE);
}

/**
 * Helper function to truncate sentence after n words.
 *
 * @param string $string
 * @param string $words
 *
 * @return string
 */
function leaf_baseline_trim_words($string, $words = 1) {
  $string = explode(' ', $string);

  if (count($string) > $words) {
    return implode(' ', array_slice($string, 0, $words)) . '...';
  }

  return implode(' ', $string);
}

/**
 * Custom submit handler.
 */
function leaf_baseline_group_membership_submit(&$form, FormStateInterface $form_state) {
  $form_value = $form_state->getValues();
  $group = \Drupal::routeMatch()->getParameter('group');
  if (is_numeric($group)) {
    // Load group entity.
    $group = Group::load($group);
  }
  $member_profile_id = $group->get("field_member_profile")->getValue()[0]['target_id'];

  // Get group object.
  $groupObj = $form_state->getFormObject()->getEntity();
  $gid = $groupObj->get('gid')->getString();

  // Create new profile.
  $profile_content = \Drupal::entityTypeManager()->getStorage('profile')->create(['type' => $member_profile_id]);

  // Update SBF profile.
  if (!empty($form_value["entity_id"])) {
    $query = \Drupal::entityQuery('profile')
      ->condition('type', $member_profile_id)
      ->condition('uid', $form_value["entity_id"][0]["target_id"])
      ->condition('field_group_id', $gid)
      ->accessCheck(TRUE);
    $pids = $query->execute();

    if (!empty($pids)) {
      $profile_id = reset($pids);
      $profile_content = Profile::load($profile_id);
    }
    else {
      // Create new profile.
      $profile_content = \Drupal::entityTypeManager()->getStorage('profile')->create(['type' => $member_profile_id]);
    }

    // UID should be same as user field into group member.
    $profile_content->set('uid', $form_value["entity_id"][0]["target_id"]);
  }

  // Set group id to hidden field.
  $profile_content->set('field_group_id', $gid);

  // Add translated content.
  if (!empty($form_value["langcode"])) {
    $langcode = $form_value["langcode"][0]['value'];

    if (has_translation($profile_content, $langcode)) {
      $profile_content_translation = $profile_content->getTranslation($langcode);

      // Set group form value to profile fields.
      $sbf_profile_type_fields_infos = \Drupal::service('entity_field.manager')->getFieldDefinitions('profile', $member_profile_id);
      foreach ($sbf_profile_type_fields_infos as $p_field => $sbf_profile_type_fields_info) {
        if (!in_array($p_field, array_keys($form_value)) || $p_field == "field_group_id" || $p_field == "langcode") {
          continue;
        }

        // Handle entity reference value submit.
        if ($sbf_profile_type_fields_info->getType() == "entity_reference") {

          // Handle all media entity reference fields.
          if (!empty($sbf_profile_type_fields_info->getSettings()["target_type"])) {
            if ($sbf_profile_type_fields_info->getSettings()["target_type"] == "media") {
              if (!empty($form_value[$p_field]["selection"])) {
                $profile_content_translation->set($p_field, $form_value[$p_field]["selection"][0]["target_id"]);
              }
              else {
                $profile_content_translation->set($p_field, NULL);
              }
            }

            if ($sbf_profile_type_fields_info->getSettings()["target_type"] == "taxonomy_term") {
              if (!empty($form_value[$p_field])) {
                $profile_content_translation->set($p_field, NULL);

                // If term is new, save it.
                foreach ($form_value[$p_field] as $i => $val) {
                  if (!empty($form_value[$p_field][$i]["target_id"])) {
                    if (is_array($form_value[$p_field][$i]["target_id"])) {
                      $taxnmy_entity = $form_value[$p_field][$i]["target_id"]["entity"];
                      $taxnmy_entity->save();
                      $form_value[$p_field][]["target_id"] = $taxnmy_entity->id();
                    }
                  }
                }

                foreach ($form_value[$p_field] as $i => $val) {
                  if (!empty($form_value[$p_field][$i]["target_id"]) && is_numeric($form_value[$p_field][$i]["target_id"])) {
                    $profile_content_translation->get($p_field)->appendItem(['target_id' => $form_value[$p_field][$i]["target_id"]]);
                  }
                }
              }
            }
          }
        }
        else {
          $profile_content_translation->set($p_field, $form_value[$p_field]);
        }
      }
      $profile_content_translation->save();
    }
    else {
      $profile_obj = Profile::load($profile_id);
      $profile_translated = $profile_obj->addTranslation($langcode, $profile_obj->toArray());

      // Set group form value to profile fields.
      $sbf_profile_type_fields_infos = \Drupal::service('entity_field.manager')->getFieldDefinitions('profile', $member_profile_id);
      foreach ($sbf_profile_type_fields_infos as $p_field => $sbf_profile_type_fields_info) {
        if (!in_array($p_field, array_keys($form_value)) || $p_field == "field_group_id" || $p_field == "langcode") {
          continue;
        }

        // Handle entity reference value submit.
        if ($sbf_profile_type_fields_info->getType() == "entity_reference") {

          // Handle all media entity reference fields.
          if (!empty($sbf_profile_type_fields_info->getSettings()["target_type"])) {
            if ($sbf_profile_type_fields_info->getSettings()["target_type"] == "media") {
              if (!empty($form_value[$p_field]["selection"])) {
                $profile_translated->set($p_field, $form_value[$p_field]["selection"][0]["target_id"]);
              }
              else {
                $profile_translated->set($p_field, NULL);
              }
            }

            if ($sbf_profile_type_fields_info->getSettings()["target_type"] == "taxonomy_term") {
              if (!empty($form_value[$p_field])) {
                $profile_translated->set($p_field, NULL);
                foreach ($form_value[$p_field] as $i => $val) {
                  $profile_translated->get($p_field)->appendItem(['target_id' => $form_value[$p_field][$i]["target_id"]]);
                }
              }
            }
          }
        }
        else {
          $profile_translated->set($p_field, $form_value[$p_field]);
        }
      }

      $profile_translated->save();
    }
  }
}

/**
 * Check if a profile as a translation for the given language.
 *
 * @param object $profile
 *   The profile object.
 * @param string $langcode
 *   The langcode.
 *
 * @return bool
 *   True (exists) or false (does not exist).
 */
function has_translation($profile, $langcode) {
  $existing_translation = \Drupal::service('entity.repository')->getTranslationFromContext($profile, $langcode);
  return ($existing_translation->langcode->value === $langcode) ? TRUE : FALSE;
}

/**
 * Implements hook_entity_view().
 */
function leaf_baseline_entity_view(array &$build, EntityInterface $entity, EntityViewDisplayInterface $display, $view_mode) {
  if ($entity->getEntityTypeId() == "group") {
    $member_profile_field_val = $entity->get("field_member_profile")->getValue();
    if (empty($member_profile_field_val)) {
      return;
    }

    $member_profile_id = $entity->get("field_member_profile")->getValue()[0]['target_id'];

    $members = $entity->getMembers();

    foreach ($members as $member) {
      $user = $member->getUser();

      // Get profile id of current group member.
      $query = \Drupal::entityQuery('profile')
        ->condition('type', $member_profile_id)
        ->condition('uid', $user->id())
        ->condition('field_group_id', $entity->id())
        ->accessCheck(TRUE);

      $pids = $query->execute();

      // If no profile created.
      if (empty($pids)) {
        $profile_content = \Drupal::entityTypeManager()->getStorage('profile')->create(['type' => $member_profile_id]);
        if (!$profile_content->hasField("field_group_id")) {
          return;
        }
        // UID should be same as user field into group member.
        $profile_content->set('uid', $user->id());

        // Set group id to hidden field.
        $profile_content->set('field_group_id', $entity->id());
        $profile_content->save();
      }
    }
  }
}

/**
 * Implements hook_entity_insert().
 */
function leaf_baseline_entity_insert(EntityInterface $entity) {
  leaf_baseline_entity_moderation($entity);
}

/**
 * Implements hook_entity_delete().
 */
function leaf_baseline_entity_delete(EntityInterface $entity) {
  leaf_baseline_entity_moderation($entity);
}

/**
 * Implements hook_entity_delete().
 */
function leaf_baseline_entity_update(EntityInterface $entity) {
  leaf_baseline_entity_moderation($entity);
}

/**
 * Helper method for all entity moderation.
 */
function leaf_baseline_entity_moderation($entity) {
  if ($entity->getEntityType()->id() == 'media') {
    if ($entity->hasField('field_media_of')) {
      $referenceItem = $entity->get('field_media_of')->getValue();

      if (!empty($referenceItem)) {
        $nid_attached_to_media = $referenceItem[0]['target_id'];
        $mediaStorage = \Drupal::entityTypeManager()->getStorage('media');
        $mids = $mediaStorage->getQuery()
          ->accessCheck(FALSE)
          ->condition('bundle', 'document')
          ->condition('field_media_of', $nid_attached_to_media)
          ->sort('created', 'DESC')
          ->execute();

        // Remove all media items from node.
        $node = Node::load($nid_attached_to_media);
        $node->field_media = [];
        $node->save();

        if (!empty($mids)) {
          foreach ($mids as $media_id) {
            $mid = $media_id;
            $node = Node::load($nid_attached_to_media);
            // Attach all media items to node.
            $node->field_media[] = ['target_id' => $mid];
            $node->save();
          }
        }
      }
    }
  }
}

/**
 * Implements hook_form_BASE_FORM_ID_alter().
 */
function leaf_baseline_form_views_exposed_form_alter(&$form, FormStateInterface $form_state, $form_id) {
  $view_ids = ['group_nodes'];

  if ($form_id == 'views_exposed_form' && in_array($form_state->get('view')->id(), $view_ids)) {
    $group = \Drupal::routeMatch()->getParameter('group');

    $form['search_parent_node'] = [
      '#type' => 'textfield',
      '#title' => t('Parent'),
      '#autocomplete_route_name' => 'leaf_baseline.autocomplete.repository',
      '#autocomplete_route_parameters' => ['gid' => !empty($group) ? $group->id() : ""],
      '#attributes' => [
        'placeholder' => "",
      ],
      '#required' => FALSE,
      '#weight' => 0,
      '#size' => 30,
    ];

    $form['#attached']['library'][] = 'leaf_baseline/group-search';
  }
}

/**
 * Given a node, find the group IDs that the node is a part of.
 *
 * @param int $nid
 *   The node ID.
 *
 * @return array
 *   An array of group IDs that the node is present in.
 */
function leaf_baseline_get_groupIds_by_entity($nid) {
  $query = \Drupal::database()->select('group_content_field_data', 'gr');
  $query->innerjoin('groups_field_data', 'gfd', 'gr.gid = gfd.id');
  $query->condition('gr.entity_id', $nid);

  // Don't include group user memberships in the query.
  $query->condition('gr.type', 'group-group_membership', '!=');

  $query->fields('gr', ['gid']);
  $result = $query->execute();

  $groupIds = [];
  foreach ($result as $record) {
    $groupIds[] = $record->gid;
  }
  return reset($groupIds);
}
